<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';
require_once 'lib/vod/vod_list_screen.php';
require_once 'lib/vod/vod_movie_screen.php';
require_once 'lib/vod/vod_series_list_screen.php';
require_once 'lib/vod/vod_favorites_screen.php';
require_once 'lib/vod/vod_history_screen.php';
require_once 'lib/vod/vod_channel_screen.php';
require_once 'lib/vod/vod_top500_screen.php';
require_once 'Smart_config.php';
require_once 'Smart_entry_handler.php';
require_once 'Smart_vod.php';
require_once 'Smart_setup_screen.php';
require_once 'Smart_vod_category_list_screen.php';
require_once 'Smart_vod_list_screen.php';
require_once 'Smart_vod_simple_list_screen.php';
require_once 'Smart_main_menu_screen.php';
require_once 'Smart_search_screen.php';
require_once 'Smart_file_screen.php';
if (HD::get_versions()=== true){
	require_once 'lib/nSmartViews.php';
}else{

	require_once 'lib/oSmartviews.php';
}
///////////////////////////////////////////////////////////////////////////

class SmartPlugin extends DefaultDunePlugin
{
    public function __construct()
    {
        $this->vod = new SmartVod();
		$this->add_screen(new SmartSetupScreen());
		$this->add_screen(new SmartFileSystemScreen());
		$this->entry_handler = new SmartEntryHandler($this->vod);
        $this->add_screen(new SmartMainMenuScreen($this->vod));		
		$this->add_screen(new SmartSearchScreen($this->vod));
        $this->add_screen(new VodFavoritesScreen($this->vod));
        $this->add_screen(new SmartVodCategoryListScreen($this->vod));
        $this->add_screen(new SmartVodListScreen($this->vod));
		$this->add_screen(new SmartVodSimpleListScreen($this->vod));
        $this->add_screen(new VodMovieScreen($this->vod));
        $this->add_screen(new VodSeriesListScreen($this->vod));
		$this->add_screen(new VodHistoryScreen($this->vod));
		$this->add_screen(new VodChannelScreen($this->vod));
		$this->add_screen(new VodTop500Screen($this->vod));
    }
}

///////////////////////////////////////////////////////////////////////////
?>
