<?php
class SmartViews
{
    ///////////////////////////////////////////////////////////////////////
    // Folder views.
	
		public static function GET_TEXT_ONE_COL_VIEWS() {
        
        return array(
                array (
                        PluginRegularFolderView::async_icon_loading => false,
                        PluginRegularFolderView::view_params => array
                            (
                            ViewParams::num_cols => 1,
                            ViewParams::num_rows => 12,
							ViewParams::paint_details => true,
							ViewParams::background_path=> SmartConfig::get_plugin_ico('one_col_bg'),
							ViewParams::background_order => 0,
							ViewParams::background_height => 1080,
							ViewParams::background_width => 1920,
							ViewParams::optimize_full_screen_background => true,
							ViewParams::paint_item_info_in_details => true,
							ViewParams::item_detailed_info_auto_line_break => true,
							ViewParams::item_detailed_info_title_color => 10,
							ViewParams::item_detailed_info_text_color => 15,
                        ),
                        PluginRegularFolderView::base_view_item_params =>
                        array
                            (
                            ViewItemParams::icon_path => 'missing://',
                            ViewItemParams::item_layout => HALIGN_LEFT,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::icon_dx => 20,
                            ViewItemParams::icon_dy => -5,
                            ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
                            ViewItemParams::item_caption_width => 1550
                        ),
                        PluginRegularFolderView::not_loaded_view_item_params => array(),
                    ), 
            );
    }
	static private function get_view_params($cols, $rows, $sel_w, $sel_h, $with_details)
    {
        return array_merge(
            array(
                ViewParams::background_path=> SmartConfig::get_plugin_ico('vod_list_bg'),
                ViewParams::background_order => 0,
				
                ViewParams::paint_path_box => true,
                ViewParams::paint_widget => true,
                ViewParams::paint_widget_background => true,
                ViewParams::paint_content_box_background => true,
                ViewParams::paint_path_box_background => true,
                ViewParams::paint_details_box_background => true,
                ViewParams::paint_help_line => true,

            ),
            array(
                ViewParams::num_cols => $cols,
                ViewParams::num_rows => $rows,
                ViewParams::icon_selection_box_width => $sel_w,
                ViewParams::icon_selection_box_height => $sel_h,
                ViewParams::paint_details => $with_details,
                ViewParams::item_detailed_info_font_size => FONT_SIZE_LARGE,
				ViewParams::item_detailed_info_auto_line_break => true,
				ViewParams::item_detailed_info_title_color => 10,
				ViewParams::item_detailed_info_text_color => 15,
                ViewParams::max_icon_width => 303,
                ViewParams::max_icon_height => 431,
                ViewParams::item_detailed_info_use_main_icon => true,
				ViewParams::item_detailed_info_font_size => FONT_SIZE_SMALL,
            ));
    }

    static private function get_item_params($w, $h, $with_details)
    {
        return array(
            ViewItemParams::item_padding_top => 0,
            ViewItemParams::item_padding_bottom => 0,
            ViewItemParams::icon_valign => VALIGN_CENTER,
            ViewItemParams::item_paint_caption => false,
            ViewItemParams::icon_width => $w,
            ViewItemParams::icon_height => $h,
            ViewItemParams::icon_scale_factor => 1.0,
            ViewItemParams::icon_sel_scale_factor => 1.1,
            // ViewItemParams::item_detailed_icon_width => 167, //solo
            // ViewItemParams::item_detailed_icon_height => 250,
        );
    }
    public static function GET_VOD_MOVIE_LIST_FOLDER_VIEWS()
	
    {
		$common_arr = array( //solo
            PluginRegularFolderView::async_icon_loading => true,
            PluginRegularFolderView::async_icon_loading_interrupt_enabled => true,

            PluginRegularFolderView::not_loaded_view_item_params => array
            (
                ViewItemParams::icon_path => "plugin_file://icons/mov_unset.png",
            ),

            PluginRegularFolderView::load_failed_view_item_params => array
            (
                ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.png',
            ),
        );
		$fullscreen_view_params = array(
            ViewParams::paint_path_box => false,
            ViewParams::paint_path_box_background => false,
            ViewParams::paint_widget => false,
            ViewParams::paint_widget_background => false,
            ViewParams::paint_content_box_background => true,
            ViewParams::paint_scrollbar => false,
            ViewParams::paint_help_line => false,

            ViewParams::content_box_x => 0,
            ViewParams::content_box_y => 0,
            ViewParams::content_box_width => 1920,
            ViewParams::content_box_height => 1080,
            ViewParams::content_box_x => 0,
            ViewParams::content_box_y => 0,
            ViewParams::content_box_width => 1920,
            ViewParams::content_box_height => 1080,
            ViewParams::content_box_padding_left => 50,
            ViewParams::content_box_padding_top => 60,
            ViewParams::content_box_padding_right => 50,
            ViewParams::content_box_padding_bottom => 60,
        );
        return array(
		#1
			array
				(
                    PluginRegularFolderView::async_icon_loading => true,
					PluginRegularFolderView::view_params => array
					(
						ViewParams::num_cols => 3,
						ViewParams::num_rows => 3,
						ViewParams::paint_details => true,
						//ViewParams::detailed_icon_scale_factor => 0,
						ViewParams::paint_item_info_in_details => true,
						ViewParams::item_detailed_info_font_size => FONT_SIZE_SMALL,

						ViewParams::paint_sandwich => true,
						ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
						ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
						ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
						ViewParams::sandwich_width => 330,
						ViewParams::sandwich_height => 186,
						ViewParams::sandwich_icon_upscale_enabled => true,
						ViewParams::sandwich_icon_keep_aspect_ratio => true,
						ViewParams::paint_item_info_in_details => true,
						ViewParams::item_detailed_info_auto_line_break => true,
						ViewParams::item_detailed_info_title_color => 10,
						ViewParams::item_detailed_info_text_color => 15,
						ViewParams::background_path=> SmartConfig::get_plugin_ico('vod_list_bg'),
						ViewParams::background_order => 0,
						ViewParams::background_height => 1080,
						ViewParams::background_width => 1920,
						ViewParams::optimize_full_screen_background => true,
					),
                        
                        PluginRegularFolderView::not_loaded_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_width => 330,
                            ViewItemParams::icon_height => 186,
                            ViewItemParams::icon_path => 'plugin_file://icons/mov_unset2.png'
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_sel_scale_factor =>1.1,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                            ViewItemParams::item_layout => HALIGN_CENTER,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::icon_dx => 10,
                            ViewItemParams::icon_dy => -5,
                            ViewItemParams::icon_width => 330,
                            ViewItemParams::icon_height => 186,
							// ViewItemParams::item_detailed_icon_width => 167, //solo
							// ViewItemParams::item_detailed_icon_height => 250,
                            ViewItemParams::icon_sel_margin_top => 0,
                            ViewItemParams::item_paint_caption => false,
                            ViewItemParams::item_caption_width => 1100
                        ),
				),
				#2
				array
				(
                        PluginRegularFolderView::async_icon_loading => true,

                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 1,
                            ViewParams::num_rows => 5,
                            ViewParams::paint_details => true,
                            ViewParams::paint_item_info_in_details => true,
							ViewParams::item_detailed_info_auto_line_break => true,
							ViewParams::item_detailed_info_title_color => 10,
							ViewParams::item_detailed_info_text_color => 15,
							ViewParams::background_path=> SmartConfig::get_plugin_ico('vod_list_bg'),
							ViewParams::background_order => 0,
							ViewParams::background_height => 1080,
							ViewParams::background_width => 1920,
							ViewParams::optimize_full_screen_background => true,
							ViewParams::item_detailed_info_font_size => FONT_SIZE_SMALL,
                            ViewParams::paint_sandwich => false,
                            ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                            ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                            ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                            ViewParams::sandwich_width => 200,
                            ViewParams::sandwich_height => 112,
                            ViewParams::sandwich_icon_upscale_enabled => true,
                            ViewParams::sandwich_icon_keep_aspect_ratio => true,
                        ),

                        PluginRegularFolderView::not_loaded_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_width => 200,
                            ViewItemParams::icon_height => 112,
                            ViewItemParams::icon_path => 'plugin_file://icons/mov_unset2.png'
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_sel_scale_factor =>1.2,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                            ViewItemParams::item_layout => HALIGN_LEFT,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::icon_dx => 10,
                            ViewItemParams::icon_dy => -5,
                            ViewItemParams::icon_width => 200,
                            ViewItemParams::icon_height => 112,
							// ViewItemParams::item_detailed_icon_width => 167, //solo
							// ViewItemParams::item_detailed_icon_height => 250,
                            ViewItemParams::icon_sel_margin_top => 0,
                            ViewItemParams::item_paint_caption => true,
                            ViewItemParams::item_caption_width => 900
                        ),
				),
				#3
				array
				(
                        PluginRegularFolderView::async_icon_loading => true,
                        PluginRegularFolderView::view_params => array
                        (
                            ViewParams::num_cols => 1,               
                            ViewParams::num_rows => 10,
                            ViewParams::paint_details => true,
                            ViewParams::paint_details => true,
                            ViewParams::paint_item_info_in_details => true,
							ViewParams::item_detailed_info_auto_line_break => true,
							ViewParams::item_detailed_info_title_color => 10,
							ViewParams::item_detailed_info_text_color => 15,
							ViewParams::background_path=> SmartConfig::get_plugin_ico('vod_list_bg'),
							ViewParams::background_order => 0,
							ViewParams::background_height => 1080,
							ViewParams::background_width => 1920,
                            ViewParams::paint_item_info_in_details => true,
                            ViewParams::item_detailed_info_font_size => FONT_SIZE_SMALL,

                            ViewParams::paint_sandwich => false,
                            ViewParams::sandwich_base => 'gui_skin://special_icons/sandwich_base.aai',
                            ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                            ViewParams::sandwich_cover => 'cut_icon://{name=sandwich_cover}',
                            ViewParams::sandwich_width => 89,
                            ViewParams::sandwich_height => 50,
                            ViewParams::sandwich_icon_upscale_enabled => true,
                            ViewParams::sandwich_icon_keep_aspect_ratio => true,
                        ),

                        PluginRegularFolderView::not_loaded_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_width => 89,
                            ViewItemParams::icon_height => 50,
                            ViewItemParams::icon_path => 'plugin_file://icons/mov_unset.png'
                        ),

                        PluginRegularFolderView::base_view_item_params => array
                        (
                            ViewItemParams::item_paint_icon => true,
                            ViewItemParams::icon_sel_scale_factor =>1.2,
                            ViewItemParams::icon_path => 'gui_skin://small_icons/movie.aai',
                            ViewItemParams::item_layout => HALIGN_LEFT,
                            ViewItemParams::icon_valign => VALIGN_CENTER,
                            ViewItemParams::icon_dx => 10,
                            ViewItemParams::icon_dy => -5,
                            ViewItemParams::icon_width => 89,
                            ViewItemParams::icon_height => 50,
							// ViewItemParams::item_detailed_icon_width => 167, //solo
							// ViewItemParams::item_detailed_icon_height => 250,
                            ViewItemParams::icon_sel_margin_top => 0,
                            ViewItemParams::item_paint_caption => true,
                            ViewItemParams::item_caption_width => 1050
                        ),
				),
		
        array_merge($common_arr,
            array(
                PluginRegularFolderView::view_params => self::get_view_params(5, 5, 243, 137, true),
                PluginRegularFolderView::base_view_item_params => self::get_item_params(221, 124, true),
            )),
        
        array_merge($common_arr,
            array(
                PluginRegularFolderView::view_params => self::get_view_params(10, 6, 162, 91, false),
                PluginRegularFolderView::base_view_item_params => self::get_item_params(147, 83, false),
            )),

        array_merge($common_arr,
            array(
                PluginRegularFolderView::view_params => array_merge(self::get_view_params(5, 5, 320, 180, false), $fullscreen_view_params),
                PluginRegularFolderView::base_view_item_params => self::get_item_params(291, 164, false),
            )),
			
       
        array_merge($common_arr,
            array(
                PluginRegularFolderView::view_params => array_merge(self::get_view_params(10, 9, 162, 91, false), $fullscreen_view_params),
                PluginRegularFolderView::base_view_item_params => self::get_item_params(147, 83, false),
            )),

			array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 1,
                    ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
					ViewParams::item_width => 250,
                    ViewParams::item_height => 141,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
					ViewParams::paint_icon_selection_box => true,
                    ViewParams::background_path=> SmartConfig::get_plugin_ico('vod_list_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
                    ViewParams::paint_content_box_background => true,
                    ViewParams::optimize_full_screen_background => true,
					ViewParams::paint_scrollbar => false,
					ViewParams::orientation => ORIENTATION_HORIZONTAL,
					ViewParams::cycle_mode_enabled => true,
					// ViewParams::cycle_mode_gap => 'auto',
					// ViewParams::cycle_mode_gap_width => 900,
					ViewParams::paint_path_box => true,
					ViewParams::scroll_animation_enabled => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.5,
                    ViewItemParams::icon_dy => 50,
                    ViewItemParams::icon_width => 250,
                    ViewItemParams::icon_height => 141,
					ViewItemParams::item_paint_unselected_caption => false,
					ViewItemParams::item_paint_caption => true,
					ViewItemParams::item_caption_dy => 200,
					ViewItemParams::item_caption_sel_dy => -50,
					ViewItemParams::item_caption_wrap_enabled => 1,
					
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
		);
    }

    public static function GET_VOD_CATEGORY_LIST_FOLDER_VIEWS()
    {
        return array(
			array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 12,
                    ViewParams::paint_details => true,
                    ViewParams::paint_item_info_in_details => true,
					ViewParams::item_detailed_info_auto_line_break => true,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('category_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
					ViewParams::item_detailed_info_title_color => 10,
					ViewParams::item_detailed_info_text_color => 15,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
    		    ViewItemParams::item_paint_icon => true,
    		    ViewItemParams::item_layout => HALIGN_LEFT,
    		    ViewItemParams::icon_valign => VALIGN_CENTER,
    		    ViewItemParams::icon_dx => 20,
    		    ViewItemParams::icon_dy => -5,
				ViewItemParams::icon_width => 55,
				ViewItemParams::icon_height => 55,
    		    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
    		    ViewItemParams::item_caption_width => 1100,
				
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 2,
                    ViewParams::num_rows => 12,
                    ViewParams::paint_details => true,
                    ViewParams::paint_item_info_in_details => true,
					ViewParams::item_detailed_info_auto_line_break => true,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('category_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
					ViewParams::item_detailed_info_title_color => 10,
					ViewParams::item_detailed_info_text_color => 15,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 20,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::icon_width => 55,
                    ViewItemParams::icon_height => 55,
                    ViewItemParams::item_caption_width => 485,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			array
			(
				PluginRegularFolderView::async_icon_loading => false,
				PluginRegularFolderView::view_params => array
				(
					ViewParams::num_cols => 1,
					ViewParams::num_rows => 12,
					ViewParams::paint_details => true,
                    ViewParams::paint_item_info_in_details => true,
					ViewParams::item_detailed_info_auto_line_break => true,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('category_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
					ViewParams::item_detailed_info_title_color => 10,
					ViewParams::item_detailed_info_text_color => 15,
				),
				PluginRegularFolderView::base_view_item_params => array
				(
					ViewItemParams::item_layout => HALIGN_LEFT,
					ViewItemParams::icon_valign => VALIGN_CENTER,
					ViewItemParams::icon_dx => 20,
					ViewItemParams::icon_dy => -5,
					ViewItemParams::icon_width => 55,
                    ViewItemParams::icon_height => 55,
					ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
					ViewItemParams::item_caption_width => 1550
				),
                PluginRegularFolderView::not_loaded_view_item_params => array (),
			),
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 3,
                    ViewParams::num_rows => 3,
                    ViewParams::paint_details => true,
                    ViewParams::paint_item_info_in_details => true,
					ViewParams::item_detailed_info_auto_line_break => true,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('category_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => true,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 3,
                    ViewParams::num_rows => 3,
                    ViewParams::paint_details => true,
                    ViewParams::paint_item_info_in_details => true,
					ViewParams::item_detailed_info_auto_line_break => true,
                    ViewParams::paint_sandwich => false,
                    // ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    // ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    // ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
                    ViewParams::sandwich_width => 250,
                    ViewParams::sandwich_height => 199,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => false,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('category_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
					ViewParams::paint_icon_selection_box => false,
					ViewParams::item_detailed_info_title_color => 10,
					ViewParams::item_detailed_info_text_color => 15,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => true,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 4,
                    ViewParams::num_rows => 3,
                    ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('category_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
					ViewParams::item_detailed_info_title_color => 10,
					ViewParams::item_detailed_info_text_color => 15,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => true,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),

        );
    }
	public static function GET_VOD_MAIN_MENU_VIEWS()
    {
        return array(
			#1
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 3,
                    ViewParams::num_rows => 3,
                    ViewParams::paint_details => true,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('main_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => true,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.2,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			#2
			array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 5,
                    ViewParams::paint_details => true,
                    ViewParams::zoom_detailed_icon => false,
					ViewParams::item_width => 170,
                    ViewParams::item_height => 98,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('main_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
					
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
    		    ViewItemParams::item_paint_icon => true,
    		    ViewItemParams::item_layout => HALIGN_LEFT,
    		    ViewItemParams::icon_valign => VALIGN_CENTER,
    		    ViewItemParams::icon_dx => 10,
    		    ViewItemParams::icon_dy => -5,
				ViewItemParams::icon_width => 170,
				ViewItemParams::icon_height => 98,
    		    ViewItemParams::item_caption_font_size => FONT_SIZE_NORMAL,
    		    ViewItemParams::item_caption_width => 950,
				ViewItemParams::icon_scale_factor => 1.0,
                ViewItemParams::icon_sel_scale_factor => 1.2,

                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			#3
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 3,
                    ViewParams::num_rows => 3,
                    ViewParams::paint_details => true,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('main_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.25,
                    ViewItemParams::icon_sel_scale_factor => 1.5,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			#4
            array
            (
                PluginRegularFolderView::async_icon_loading => false,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 4,
                    ViewParams::num_rows => 2,
                    ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
                    ViewParams::sandwich_width => 245,
                    ViewParams::sandwich_height => 140,
                    ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
					ViewParams::background_path=> SmartConfig::get_plugin_ico('main_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_CENTER,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::item_paint_caption => true,
                    ViewItemParams::icon_scale_factor => 1.25,
                    ViewItemParams::icon_sel_scale_factor => 1.5,
					
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			#5
			array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 1,
                    ViewParams::num_rows => 12,
                    ViewParams::paint_details => true,
					ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
					ViewParams::background_path=> SmartConfig::get_plugin_ico('main_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
					ViewParams::optimize_full_screen_background => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => HALIGN_LEFT,
                    ViewItemParams::icon_valign => VALIGN_CENTER,
                    ViewItemParams::icon_dx => 10,
                    ViewItemParams::icon_dy => -5,
                    ViewItemParams::icon_width => 84,
                    ViewItemParams::icon_height => 48,
                    ViewItemParams::item_caption_width => 1060,
                    ViewItemParams::item_caption_font_size => 28,
                    ViewItemParams::icon_path => 'plugin_file://icons/channel_unset.png',
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
			
			#6
			array
            (
                PluginRegularFolderView::async_icon_loading => true,

                PluginRegularFolderView::view_params => array
                (
                    ViewParams::num_cols => 5,
                    ViewParams::num_rows => 1,
                    ViewParams::paint_details => false,
                    ViewParams::paint_sandwich => true,
                    ViewParams::sandwich_base => SmartConfig::get_plugin_ico('category_sandwich_base'),
                    ViewParams::sandwich_mask => 'cut_icon://{name=sandwich_mask}',
                    ViewParams::sandwich_cover => SmartConfig::get_plugin_ico('sandwich_cover'),
					ViewParams::item_width => 246,
                    ViewParams::item_height => 246,
                     ViewParams::sandwich_icon_upscale_enabled => true,
                    ViewParams::sandwich_icon_keep_aspect_ratio => true,
					ViewParams::paint_icon_selection_box => true,
                    ViewParams::background_path=> SmartConfig::get_plugin_ico('vod_list_bg'),
					ViewParams::background_order => 0,
					ViewParams::background_height => 1080,
					ViewParams::background_width => 1920,
                    ViewParams::paint_content_box_background => true,
                    ViewParams::optimize_full_screen_background => true,
					ViewParams::paint_scrollbar => false,
					ViewParams::orientation => ORIENTATION_HORIZONTAL,
					ViewParams::cycle_mode_enabled => true,
					// ViewParams::cycle_mode_gap => 'auto',
					// ViewParams::cycle_mode_gap_width => 900,
					ViewParams::paint_path_box => true,
					ViewParams::scroll_animation_enabled => true,
                ),

                PluginRegularFolderView::base_view_item_params => array
                (
                    ViewItemParams::item_paint_icon => true,
                    ViewItemParams::item_layout => VALIGN_CENTER,
                    ViewItemParams::icon_valign => HALIGN_CENTER,
                    ViewItemParams::item_paint_caption => false,
                    ViewItemParams::icon_scale_factor => 1.0,
                    ViewItemParams::icon_sel_scale_factor => 1.0,
                    #ViewItemParams::icon_dy => -5,
                    ViewItemParams::icon_width => 246,
                    ViewItemParams::icon_height => 246,
					ViewItemParams::icon_sel_width => 246,
                    ViewItemParams::icon_sel_height => 246,
                ),

                PluginRegularFolderView::not_loaded_view_item_params => array (),
            ),
        );
    }
}
?>
